 package org.sky.admin.security;

import org.sky.core.launch.utils.INetUtil;
import org.springframework.http.HttpHeaders;
import org.springframework.http.server.reactive.ServerHttpRequest;
import org.springframework.security.authorization.AuthorizationDecision;
import org.springframework.security.authorization.ReactiveAuthorizationManager;
import org.springframework.security.core.Authentication;
import org.springframework.security.web.server.authorization.AuthorizationContext;
import org.springframework.web.server.ServerWebExchange;
import reactor.core.publisher.Mono;

import java.net.InetSocketAddress;
import java.util.Optional;

/**
 * 内网认证管理，内网放行，外网认证
 *
 */
public class InternalAuthorizationManager implements ReactiveAuthorizationManager<AuthorizationContext> {
	private static final String HEADER_X_FORWARDED_FOR = "X-Forwarded-For";

	@Override
	public Mono<AuthorizationDecision> check(Mono<Authentication> authentication, AuthorizationContext context) {
		return Mono.just(getAuthorizationDecision(context));
	}

	private static AuthorizationDecision getAuthorizationDecision(AuthorizationContext context) {
		return new AuthorizationDecision(isInternalNet(context));
	}

	/**
	 * 判断是否内网 ip 请求
	 *
	 * @param context AuthorizationContext
	 * @return 是否内网 ip
	 */
	private static boolean isInternalNet(AuthorizationContext context) {
		ServerHttpRequest request = Optional.ofNullable(context)
			.map(AuthorizationContext::getExchange)
			.map(ServerWebExchange::getRequest)
			.orElse(null);
		if (request == null) {
			return false;
		}
		HttpHeaders headers = request.getHeaders();
		// 如果没有 X-Forwarded-For 代表为 admin 拉取
		if (!headers.containsKey(HEADER_X_FORWARDED_FOR)) {
			return true;
		}
		return Optional.of(request)
			.map(ServerHttpRequest::getRemoteAddress)
			.map(InetSocketAddress::getAddress)
			.map(INetUtil::isInternalIp)
			.orElse(false);
	}

}
